#
#       TRISPEC REDUCTION SUB ROUTINE
#
#       triiqu.cl: Make I, q, u spectra
#
# sn06jc_01_hwp225_00_IR1.od.0002.fits

procedure triiqu( infile, bandcode )

string infile { prompt = "Head name of input images" }
string bandcode { prompt = "select OPT, IR1 or IR2" }

begin

  string infn1, infn2, infn3, infn4
  string inhead, bandstr
  file in00o, in00e, in45o, in45e
  file in23o, in23e, in68o, in68e
  file in00or, in00er, in45or, in45er
  file in23or, in23er, in68or, in68er
  file fnq, fnu, fni, fnr
  file outtab
  file fneoo00, fneoo45, fneoo23, fneoo68
  file fn00o45, fn23o68
  string buf = ""
  file tmp_fn1, tmp_fn2, tmp_fn3, tmp_fn4
  file tmp_fn5
  int i
  int flag_da

  imred
#  crutil
  ccdred

  task $paste = "$foreign"  
  task $awk = "$foreign"  

  inhead = infile
  bandstr = bandcode

  infn1 = inhead//"_hwp000_00_"//bandstr
  infn2 = inhead//"_hwp225_00_"//bandstr
  infn3 = inhead//"_hwp450_00_"//bandstr
  infn4 = inhead//"_hwp675_00_"//bandstr

  in00o = infn1//".od.0001.fits"
  in00e = infn1//".od.0002.fits"
  in23o = infn2//".od.0001.fits"
  in23e = infn2//".od.0002.fits"
  in45o = infn3//".od.0001.fits"
  in45e = infn3//".od.0002.fits"
  in68o = infn4//".od.0001.fits"
  in68e = infn4//".od.0002.fits"

  in00or = infn1//".or.0001.fits"
  in00er = infn1//".or.0002.fits"
  in23or = infn2//".or.0001.fits"
  in23er = infn2//".or.0002.fits"
  in45or = infn3//".or.0001.fits"
  in45er = infn3//".or.0002.fits"
  in68or = infn4//".or.0001.fits"
  in68er = infn4//".or.0002.fits"

  fnq = inhead//bandstr//"q.fits"
  fnu = inhead//bandstr//"u.fits"
  fni = inhead//bandstr//"i.fits"
  fnr = inhead//bandstr//"r.fits"

  outtab = inhead//bandstr//".xy"

  fneoo00 = inhead//"eoo.00.fits"
  fneoo23 = inhead//"eoo.23.fits"
  fneoo45 = inhead//"eoo.45.fits"
  fneoo68 = inhead//"eoo.68.fits"
  fn00o45 = inhead//"00o45.fits"
  fn23o68 = inhead//"23o68.fits"

  tmp_fn1 = mktemp( "tri.tmp.fn." )//".fits"
  tmp_fn2 = mktemp( "tri.tmp.fn." )//".fits"
  tmp_fn3 = mktemp( "tri.tmp.fn." )//".fits"
  tmp_fn4 = mktemp( "tri.tmp.fn." )//".fits"

  if( access( in00o ) == 0 )
  {
    printf( "%s:  Not found.\n", in00o )
    return
  }
  if( access( in00e ) == 0 )
  {
    printf( "%s:  Not found.\n", in00e )
    return
  }
  if( access( in45o ) == 0 )
  {
    printf( "%s:  Not found.\n", in45o )
    return
  }
  if( access( in45e ) == 0 )
  {
    printf( "%s:  Not found.\n", in45e )
    return
  }
  if( access( in23o ) == 0 )
  {
    printf( "%s:  Not found.\n", in23o )
    return
  }
  if( access( in23e ) == 0 )
  {
    printf( "%s:  Not found.\n", in23e )
    return
  }
  if( access( in68o ) == 0 )
  {
    printf( "%s:  Not found.\n", in68o )
    return
  }
  if( access( in68e ) == 0 )
  {
    printf( "%s:  Not found.\n", in68e )
    return
  }

  if( access( in00or ) == 0 )
  {
    printf( "%s:  Not found.\n", in00or )
    return
  }
  if( access( in00er ) == 0 )
  {
    printf( "%s:  Not found.\n", in00er )
    return
  }
  if( access( in45or ) == 0 )
  {
    printf( "%s:  Not found.\n", in45or )
    return
  }
  if( access( in45er ) == 0 )
  {
    printf( "%s:  Not found.\n", in45er )
    return
  }
  if( access( in23or ) == 0 )
  {
    printf( "%s:  Not found.\n", in23or )
    return
  }
  if( access( in23er ) == 0 )
  {
    printf( "%s:  Not found.\n", in23er )
    return
  }
  if( access( in68or ) == 0 )
  {
    printf( "%s:  Not found.\n", in68or )
    return
  }
  if( access( in68er ) == 0 )
  {
    printf( "%s:  Not found.\n", in68er )
    return
  }


  if( access( fnq ) == 1 )
    imdelete( fnq, ver- )
  if( access( fnu ) == 1 )
    imdelete( fnu, ver- )
  if( access( fni ) == 1 )
    imdelete( fni, ver- )
  if( access( fnr ) == 1 )
    imdelete( fnr, ver- )
  if( access( outtab ) == 1 )
    delete( outtab, ver- )

  if( access( fneoo00 ) == 1 )
    imdelete( fneoo00, ver- )
  if( access( fneoo45 ) == 1 )
    imdelete( fneoo45, ver- )
  if( access( fneoo23 ) == 1 )
    imdelete( fneoo23, ver- )
  if( access( fneoo68 ) == 1 )
    imdelete( fneoo68, ver- )
  if( access( fn00o45 ) == 1 )
    imdelete( fn00o45, ver- )
  if( access( fn23o68 ) == 1 )
    imdelete( fn23o68, ver- )

  if( access( tmp_fn1 ) == 1 )
    imdelete( tmp_fn1, ver- )
  if( access( tmp_fn2 ) == 1 )
    imdelete( tmp_fn2, ver- )
  if( access( tmp_fn3 ) == 1 )
    imdelete( tmp_fn3, ver- )
  if( access( tmp_fn4 ) == 1 )
    imdelete( tmp_fn4, ver- )

print( "ok1" )
  flag_da = 0
  imgets( in00e, 'DISPAXIS' )
  flag_da = int( imgets.value )
  if( flag_da == 0 )
  {
    printf( "DispAxis = 0 in %s. Skip.\n", in00e )
    exit
  }
print( "ok2" )

  imarith( in00e, "/", in00o, fneoo00, ver- )
  imarith( in45e, "/", in45o, fneoo45, ver- )
  imarith( in23e, "/", in23o, fneoo23, ver- )
  imarith( in68e, "/", in68o, fneoo68, ver- )

  imarith( fneoo00, "/", fneoo45, fn00o45, ver- )
  imarith( fneoo23, "/", fneoo68, fn23o68, ver- )

  imfunc( fn00o45, tmp_fn1, function="sqrt", ver- )
  imarith( tmp_fn1, "-", 1.0, tmp_fn2, ver- )
  imarith( tmp_fn1, "+", 1.0, tmp_fn3, ver- )
  imarith( tmp_fn2, "/", tmp_fn3, fnq, ver- )
  imdelete( tmp_fn1, ver- )
  imdelete( tmp_fn2, ver- )
  imdelete( tmp_fn3, ver- )

  imfunc( fn23o68, tmp_fn1, function="sqrt", ver- )
  imarith( tmp_fn1, "-", 1.0, tmp_fn2, ver- )
  imarith( tmp_fn1, "+", 1.0, tmp_fn3, ver- )
  imarith( tmp_fn2, "/", tmp_fn3, fnu, ver- )
  imdelete( tmp_fn1, ver- )
  imdelete( tmp_fn2, ver- )
  imdelete( tmp_fn3, ver- )


  imsum( in00o//","//in00e//","//in45o//","//in45e//","//in23o//","\
         //in23e//","//in68o//","//in68e, fni, option="sum" )
  imsum( in00or//","//in00er//","//in45or//","//in45er//","//in23or//","\
         //in23er//","//in68or//","//in68er, fnr, option="sum" )

  listpix( fnr, wcs="world", ver-, > tmp_fn1 )
  listpix( fnq, wcs="world", ver-, > tmp_fn2 )
  listpix( fnu, wcs="world", ver-, > tmp_fn3 )
  paste( tmp_fn1, tmp_fn2, tmp_fn3, > tmp_fn4 )
  if( flag_da == 1 )
  {
    awk( "'{print $1, $3, $6, $9}'", tmp_fn4, > outtab )
  }
  else
  {
    awk( "'{print $2, $3, $6, $9}'", tmp_fn4, > outtab )
  }
  delete( tmp_fn1, ver- )
  delete( tmp_fn2, ver- )
  delete( tmp_fn3, ver- )
  delete( tmp_fn4, ver- )

###  Write log ###

  tmp_fn5 = "list."//inhead
  printf( "%s\n%s\n%s\n%s\n", in00o, in45o, in23o, in68o, > tmp_fn5 )
  trimjdave( tmp_fn5 )
  delete( tmp_fn5, ver- )

end




