#
#       TRI REDUCTION SUB ROUTINE
#
#       average GT data
#
#       1997/09/09      K.Kawabata ver.1.00
#       1997/05/31      K.Kawabata ver.2.10
#       1999/05/24      K.Kawabata ver.2.20  list diaph
#       2000/02/29      K.Kawabata ver.3.00  comment
#
#

procedure trigtave

begin

#  string lgtfileid = "g*l*0.tmp1"
#  string ugtfileid = "g*u*0.tmp1"
  string lgtfileid = "*0.ins"
  string ugtfileid = "*0.ins"

  file avelist
  file fn_llog = "trigtavel.dat"
  file fn_ulog = "trigtaveu.dat"

  file lcortab = "gtcorl.xy"
  file ucortab = "gtcoru.xy"
  string fn[200], shdiaph[200], cmnt[200]
  string buf = ""
  string buf1, buf2, buf3, buf4, buf5, buf6, buf7
  file tmp_list
  string gthead, diaph

  int c, i
  int n_list
  int runfac = 1

  int flag_lsel, flag_usel

  tmp_list = mktemp( "tri.tmp.list." )


  print( "" )
  print( "-------------------" )
  print( " Averaging GT data"
  print( "-------------------" )
  print( "" )

  gthead = envget( "_gthead" )
  avelist = envget( "_avelog" )

#----- check average log

  if( access( avelist ) == 0 )
  {
    printf( "'%s' not found.\n", avelist )
    bye
  }

#----- select diaphragm

  printf( "Select Diaphragm  [1]:2HL [2]:2S2  >> " )
  
  c = scan( buf )
  while( buf != "1" && buf != "2" )
    c = scan( buf )
  if( buf == "1" )
    diaph = "2HL"
  if( buf == "2" )
    diaph = "2S2"

  lcortab = gthead//diaph//"L"
  ucortab = gthead//diaph//"U"

#----- check old data file

  if( access( lcortab ) == 1 || access( ucortab ) == 1)
  {
    printf( "Detected old averaged table(s), '%s' or '%s'\n",\
            lcortab, ucortab )
    printf( "Delete? [y/n] >> ", fn_llog )
    c = scan( buf )
    while( buf != "n" && buf != "y" )
      c = scan( buf )
    if( buf == "n" )
    {
      printf( "Please rename '%s' and retry.\n", fn_llog )
      bye
    }
    if( access( lcortab ) )
      delete( lcortab, ver- )
    if( access( ucortab ) )
      delete( ucortab, ver- )
  }

  if( access( fn_llog ) == 1 )
  {
    printf( "Old '%s' exists. Delete? [y/n] >> ", fn_llog )
    c = scan( buf )
    while( buf != "n" && buf != "y" )
      c = scan( buf )
    if( buf == "n" )
    {
      printf( "Please rename '%s' and retry.\n", fn_llog )
      bye
    }
    delete( fn_llog, ver- )
    printf( "", >> fn_llog )
  }

  if( access( fn_ulog ) == 1 )
  {
    printf( "Old '%s' exists. Delete? [y/n] >> ", fn_ulog )
    c = scan( buf )
    while( buf != "n" && buf != "y" )
      c = scan( buf )
    if( buf == "n" )
    {
      printf( "Please rename '%s' and retry.\n", fn_ulog )
      bye
    }
    delete( fn_ulog, ver- )
    printf( "", >> fn_ulog )
  }

#----- make log file

lowerhole:

#----- lower hole

  flag_lsel = 0
  sections( lgtfileid, option="fullname", >> tmp_list )
  n_list = sections.nimages
  if( n_list == 0 )
  {
    printf( "Cannot find any table. Skip lower hole.\n" )
    delete( tmp_list, ver- )
    goto upperhole
  }

  i = 0
  list = tmp_list
  while( fscan( list, buf ) != EOF )
  {
    i += 1
    fn[i] = buf
  }
  delete( tmp_list, ver- )

  for( i=1; i<=n_list; i+=1 )
  {
    shdiaph[i] = "UNDEF"
    buf7 = ""
    list = avelist
    while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7 ) != EOF )
    {
      if( buf == fn[i] )
      {
        shdiaph[i] = buf1
	cmnt[i] = buf7
	break
      }
      buf7 = ""
    }
  }

  printf( "Following tables are found\n" )
  for( i=1; i<=n_list; i+=1 )
    printf( "%2d :  %s %s %s\n", i, fn[i], shdiaph[i], cmnt[i] )

  printf( "Select for %s group\n", lcortab )

nextstep1:

  printf( "Input number to be averaged ([0]: end lower-hole) >> " )
  while( scan( buf ) != 1 ){}
  if( buf == "0" )
    goto upperhole
  c = int( buf )
  if( c < 0 || c > n_list )
    goto nextstep1

  printf( "%s\n", fn[c], >> fn_llog )
  flag_lsel += 1
  
  goto nextstep1

upperhole:

#----- upper hole

  flag_usel = 0
  sections( ugtfileid, option="fullname", >> tmp_list )
  n_list = sections.nimages
  if( n_list == 0 )
  {
    printf( "Cannot find any table. Skip upper hole.\n" )
    delete( tmp_list, ver- )
    goto averaging
  }

  i = 0
  list = tmp_list
  while( fscan( list, buf ) != EOF )
  {
    i += 1
    fn[i] = buf
  }
  delete( tmp_list, ver- )

  for( i=1; i<=n_list; i+=1 )
  {
    shdiaph[i] = "UNDEF"
    list = avelist
    buf7 = ""
    while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7 ) != EOF )
    {
      if( buf == fn[i] )
      {
        shdiaph[i] = buf1
	cmnt[i] = buf7
	break
      }
      buf7 = ""
    }
  }

  printf( "Following tables are found\n" )
  for( i=1; i<=n_list; i+=1 )
    printf( "%2d :  %s %s %s\n", i, fn[i], shdiaph[i], cmnt[i] )

  printf( "Select for %s group\n", ucortab )

nextstep2:

  printf( "Input number to be averaged ([0]: end upper-hole) >> " )
  while( scan( buf ) != 1 ){}
  if( buf == "0" )
    goto averaging
  c = int( buf )
  if( c < 0 || c > n_list )
    goto nextstep2

  printf( "%s\n", fn[c], >> fn_ulog )
  flag_usel += 1
  
  goto nextstep2

averaging:

#--- runninng-mean factor

  printf( "Running-mean factor (pixel unit) >> " )
  c = scan( runfac )

 
#---- average

  if( access( fn_llog ) == 0 )
  {
    printf( "Cannot find '%s'. Ignore lower hole.\n", fn_llog )
  }
  else
  {
    printf( "Averaging %s --> %s\n", fn_llog, lcortab )
    trigtavesub( fn_llog, lcortab, runfac )
  }

  if( access( fn_ulog ) == 0 )
  {
    printf( "Cannot find '%s'. Ignore upper hole.\n", fn_ulog )
  }
  else
  {
    printf( "Averaging %s --> %s\n", fn_ulog, ucortab )
    trigtavesub( fn_ulog, ucortab, runfac )
  }

end
