#
#       TRI REDUCTION SUB ROUTINE
#
#      Scaling and modify count distribution for x direction
#                                    (using data made by tri1to1y.cl)
#                                                 : triscxsub.cl
#
#       2005/04/07   Modified by M.Isogai    for iraf v2.12
#

procedure triscx( infilee, infileo, ref_dir, extfile, ordfile )

file infilee { prompt = "Input extraordinary image" }
file infileo { prompt = "Input ordinary image" }
string ref_dir { prompt = "Directry of fitted coef. table" }
file extfile { prompt = "Output image of extraordinary ray" }
file ordfile { prompt = "Output image of ordinary ray" }

begin

  file infne, infno, outfne, outfno
  file fn_fite, fn_fito, fn_lmd
  file fn_fite1, fn_fito1, fn_lmd1
  string refdir
  int i, j, k, n_list, c
  int nx, ny
  string buf = ""
  real c0[40], c1[40], c2[40], c3[40], c4[40], c5[40]
  string buf1, buf2, buf3
  int n_version      # IRAF version (210 or 211)

#----

  fn_fite1 = envget( "_1to1se" )
  fn_fito1 = envget( "_1to1so" )
  fn_lmd1 = envget( "_1to1sw" )

  infne = infilee
  infno = infileo
  refdir = ref_dir
  outfne = extfile
  outfno = ordfile

  fn_fite = refdir//fn_fite1
  fn_fito = refdir//fn_fito1
  fn_lmd = refdir//fn_lmd1


#----- IRAF version check

  buf1 = envget( "version" )
  c = stridx( "V", buf1 )
  buf2 = substr( buf1, c, ( c + 4 ) )

  n_version = 0

  if( buf2 == "V2.11" || buf2 == "V2.12" || buf2 == "V2.13" || buf2 == "V2.14")
  {
    n_version = 211
  }
  else
  {
    if( buf2 == "V2.10" )
    {
      n_version = 210
    }
  }

  if( n_version == 0 )
  {
    printf( "IRAF version check failed.\n" )
    printf( "Please input like next line, and restart 'trired'\n"
    printf( "cl> set version V2.10  (V2.10 and V2.11 are valid)\n"
    bye
  }

#---

  if( access( fn_fite ) == 0 )
  {
    printf( "Cannot find '%s'\n", fn_fite )
    bye
  }
  if( access( fn_fito ) == 0 )
  {
    printf( "Cannot find '%s'\n", fn_fito )
    bye
  }

  if( access( infne ) == 0 )
  {
    printf( "Cannot find '%s'\n", infne )
    bye
  }
  if( access( infno ) == 0 )
  {
    printf( "Cannot find '%s'\n", infno )
    bye
  }

#---- make FITS file

  copy( infne, outfne, ver- )
  copy( infno, outfno, ver- )

#---- transform

printf( "e " )
#sleep( 1 )
wait
#print( "e...", infne, fn_fite, fn_lmd, outfne )
  tritfx( infne, fn_fite, fn_lmd, outfne )

printf( "o " )
#sleep( 1 )
wait
  tritfx( infno, fn_fito, fn_lmd, outfno )
#print( "o...", infne, fn_fite, fn_lmd, outfne )

#  delete( infne, ver- )
#  delete( infno, ver- )

#---- conversion to iraf format

  
end
