#
#       TRI REDUCTION SUB ROUTINE
#
#       Sky sutraction (OBJ+FLAT1+FLAT2)      : triskysub.cl
#
#       1995/10/16      K.Kawabata  Ver.0.10  for CRYOCAM manual reduc
#       1997/04/30      K.Kawabata  Ver.1.00  
#       1998/04/20      K.Kawabata  Ver.2.00  unification
#       1998/05/31      K.Kawabata  Ver.2.10
#       2000/02/29      K.Kawabata  Ver.3.00 for SITe-CCD
#

procedure triskysub


begin

  string trilist[500]
  string shorttyp[500], title[500]
  string exptime[500], diaph[500], filter[500]
  string slit[500]
  string listoflist
  int n_list
  file logfn

  file fn, fnnexte, fnnexto
  string fnflat
  string fn_f4
  string fn_stack[500]
  int n_image
  string fnobe, fnobo
  string fnobe1, fnf1e1
  string fnobe2, fnf1e2
  string fnobo1, fnf1o1
  string fnobo2, fnf1o2
  file tmp_list
  file tmp_fn1, tmp_fn2, tmp_fn3, tmp_fn4, tmp_fn5
  string buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7
  string caldir, rdir
  int c, i, j
  int flag_uplow  #  0:lower  1: upper  -1:other

  int theta_n
  real theta

  int flag_erase # 0:keep old images, 1:erase old images
  int flag_inquiry   # 1: 'flag_overwrite' applys to all image
  int flag_overwrite # 0:skip 1:overwrite
  int flag_ver       # 0:no display 1:display

  string prmfile
  int flag_cr = 0

#--- initial settings

  logfn = envget( "_logfile" )

  if( access( "tri.tmp.time" ) == 1 )
    delete( "tri.tmp.time", ver- )
  time >> tri.tmp.time
  list = "tri.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "tri.tmp.time", ver- )

  print( "" )
  printf( "%s %s\n", buf1, buf2 )
  print( "-----------------" )
  print( " Sky subtraction" )
  print( "-----------------" )
  print( "" )

  print( "", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  print( "-----------------", >> logfn )
  print( " Sky subtraction", >> logfn )
  print( "-----------------", >> logfn )
  print( "", >> logfn )

  listoflist = envget( "_rootlist" )
  caldir = envget( "_caldir" )
  fn_f4 = envget( "_fl2s21" )

  tmp_list = mktemp( "tri.tmp.list." )
  tmp_fn1 = mktemp( "tri.tmp.image." )
  tmp_fn2 = mktemp( "tri.tmp.image." )
  tmp_fn3 = mktemp( "tri.tmp.image." )
  tmp_fn4 = mktemp( "tri.tmp.image." )
  tmp_fn5 = mktemp( "tri.tmp.image." )

  if( access( listoflist ) == 0 )
  {
    print( "Cannot find "//listoflist//"   Please do trigroup" )
    print( "Cannot find "//listoflist//"   Please do trigroup", >> logfn )
    bye
  }

#--- Verbose Mode

  if( envget( "_fg_ver" ) == "1" )
  {
    flag_ver = 1
  }
  else
  {
    if( envget( "_fg_ver" ) == "2" )
    {
      flag_ver = 0
    }
    else
    {
      printf( "'triinit' process is incomplete.(_fg_ver) Retry.\n" )
      printf( "'triinit' process is incomplete.(_fg_ver) Retry.\n", >> logfn )
      bye
    }
  }

#----- Replace Mode

  if( envget( "_fg_mode" ) == "1" )
  {
    flag_inquiry = 1
    flag_overwrite = 1
  }
  else
  {
    if( envget( "_fg_mode" ) == "2" )
    {
      flag_inquiry = 1
      flag_overwrite = 0
    }
    else
    {
      if( envget( "_fg_mode" ) == "3" )
      {
        flag_inquiry = 0
        flag_overwrite = 0
      }
      else
      {
        printf( "'triinit' process is incomplete.(_fg_mode) Retry.\n" )
        printf( "'triinit' process is incomplete.(_fg_mode) Retry.\n",\
                >> logfn )
        bye
      }
    }
  }
    
#----- Erase/Reserve old image

  if( envget( "_fg_del2" ) == "1" )
  {
    flag_erase = 1
  }
  else
  {
    if( envget( "_fg_del2" ) == "2" )
    {
      flag_erase = 0
    }
    else
    {
      printf( "'triinit' process is incomplete.(_fg_del2) Retry.\n" )
      printf( "'triinit' process is incomplete.(_fg_del2) Retry.\n", >> logfn )
      bye
    }
  }

#----- scanning the list file

  n_list = 0
  list = listoflist

  while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7) != EOF )
  {
    if( substr( buf1, 1, 3 ) != "TRI" )
    {
      print( "The list-file ", listoflist, " is not produced by TRIGROUP.CL" )
      print( "The list-file ", listoflist, " is not produced by TRIGROUP.CL",\
             >> logfn )
      break
    }
    n_list += 1
    trilist[n_list] = buf1
    shorttyp[n_list] = buf2
    title[n_list] = buf3
    exptime[n_list] = buf4
    diaph[n_list] = buf5
    filter[n_list] = buf6
    slit[n_list] = buf7
  }

#----- main routine

  for( i=1; i<=n_list; i+=1 )
  {
    if( shorttyp[i] != "DAR" && shorttyp[i] != "BIA" &&\
        shorttyp[i] != "NEA" )
    {

#----- check diaphragm

      fnflat = "none"
      rdir = "none"

      if( substr( diaph[i], 1, 3 ) == "2S2" )
      {
        fnflat = fn_f4
	rdir = caldir
      }

      if( fnflat == "none" ){
        printf( "Unknown Diaph type in %s (%s)\n", trilist[i], diaph[i] )
        printf( "Unknown Diaph type in %s (%s)\n", trilist[i], diaph[i],\
                >> logfn )
	next
      }

      c = strlen( diaph[i] )
      if( substr( diaph[i], 4, 4 ) == "L" )
      {
        flag_uplow = 0
        printf( "--- OBJECT LIST : %s  LOWER (%s) ---\n",\
	        trilist[i], fnflat )
        printf( "--- OBJECT LIST : %s  LOWER (%s) ---\n",\
	        trilist[i], fnflat, >> logfn )
      }
      else
      {
          flag_uplow = -1
          printf( "%s did not used two diaphragm mode\n", trilist[i] )
          printf( "%s did not used two diaphragm mode\n", trilist[i],\
                  >> logfn )
	  next
      }

#--- paramfile

      prmfile = trilist[i]//".prm"

      if( access( prmfile ) == 0 )
      {
        printf( "Cannot find '%s'.\n", prmfile )
        next
      }
      list = prmfile
      if( fscan( list, buf, buf, buf, buf, buf1, buf, buf, buf ) != 8 )
      {
        printf( "Read error in '%s'\n", prmfile )
        printf( "Read error in '%s'\n", prmfile, >> logfn )
        bye
      }
      if( substr( buf1, 1, 1 ) == "1" )
      {
        printf( " Cosmic-ray reduction ON for this group.\n" )
        printf( " Cosmic-ray reduction ON for this group.\n", >> logfn )
        flag_cr = 1
      }
      else
      {
        printf( " Cosmic-ray reduction OFF for this group.\n" )
        printf( " Cosmic-ray reduction OFF for this group.\n", >> logfn )
        flag_cr = 0
      }

#----- choose OBJ/SKY spectra

      sed( 's/fits//', trilist[i], > tmp_list )

      n_image = 0
      list = tmp_list
      while( fscan( list, buf ) != EOF )
      {
        n_image += 1
	fn_stack[n_image] = buf
      }
      delete( tmp_list, ver- )

      for( j=1; j<=n_image; j+=1 )
      {
        fn = fn_stack[j]

        if( flag_uplow == 0 )
	{
          fnobe1 = fn//"px.1"
          fnobo1 = fn//"px.2"
#          fnobe2 = fn//"px.1"
#          fnobo2 = fn//"px.2"
          fnobe = fn//"sk.1"
          fnobo = fn//"sk.2"

          if( j < n_image )
	  {
            fnnexte = fn_stack[j+1]//"px.1"
            fnnexto = fn_stack[j+1]//"px.2"
	  }
	  else
	  {
            fnnexte = "none"
            fnnexto = "none"
	  }

          if( access( fnobe1//".fits" ) == 0 )
	  {
            printf( "%s--(not exist. skip.)  ", fnobe1 )
            printf( "%s--(not exist. skip.)  ", fnobe1, >> logfn )
            next
	  }
          imgets( fnobe1, 'POS-HWP' )
          theta = real( imgets.value )
          theta_n = int( theta / 22.499999 )

          fnf1e1 = rdir//fnflat//theta_n//".ft.1"
          fnf1o1 = rdir//fnflat//theta_n//".ft.2"
#          fnf1e2 = rdir//fnflat//theta_n//".px.3"
#          fnf1o2 = rdir//fnflat//theta_n//".px.4"
        }
#        else
#        {
#          fnobe1 = fn//"px.1"
#          fnobo1 = fn//"px.2"
#          fnobe2 = fn//"px.3"
#          fnobo2 = fn//"px.4"
#          fnobe = fn//"sk.1"
#          fnobo = fn//"sk.2"
#
#          if( j < n_image )
#	  {
#            fnnexte = fn_stack[j+1]//"px.1"
#            fnnexto = fn_stack[j+1]//"px.2"
#	  }
#	  else
#	  {
#            fnnexte = "none"
#            fnnexto = "none"
#	  }
#
#          if( access( fnobe1//".fits" ) == 0 )
#	  {
#            printf( "%s--(not exist. skip.)  ", fnobe1 )
#            printf( "%s--(not exist. skip.)  ", fnobe1, >> logfn )
#            next
#	  }
#          imgets( fnobe1, 'POS-HWP' )
#          theta = real( imgets.value )
#          theta_n = int( theta / 22.499999 )
#
#          fnf1e1 = rdir//fnflat//theta_n//".px.1"
#          fnf1o1 = rdir//fnflat//theta_n//".px.2"
#          fnf1e2 = rdir//fnflat//theta_n//".px.3"
#          fnf1o2 = rdir//fnflat//theta_n//".px.4"
#        }

	if( access( fnf1e1//".fits" ) == 0 )
	{
	  printf( "FLAT: %s not found. Skip.\n", fnf1e1 )
	  printf( "FLAT: %s not found. Skip.\n", fnf1e1, >> logfn )
	  next
	}
	if( access( fnf1o1//".fits" ) == 0 )
	{
	  printf( "FLAT: %s not found. Skip.\n", fnf1o1 )
	  printf( "FLAT: %s not found. Skip.\n", fnf1o1, >> logfn )
	  next
	}
#	if( access( fnf1e2//".fits" ) == 0 )
#	{
#	  printf( "FLAT: %s not found. Skip.\n", fnf1e2 )
#	  printf( "FLAT: %s not found. Skip.\n", fnf1e2, >> logfn )
#	  next
#	}
#	if( access( fnf1o2//".fits" ) == 0 )
#	{
#	  printf( "FLAT: %s not found. Skip.\n", fnf1o2 )
#	  printf( "FLAT: %s not found. Skip.\n", fnf1o2, >> logfn )
#	  next
#	}

#        if( access( fnobe1//".fits" ) == 0 || access( fnobo1//".fits" ) == 0 ||\
#            access( fnobe2//".fits" ) == 0 || access( fnobo2//".fits" ) == 0 )
        if( access( fnobe1//".fits" ) == 0 || access( fnobo1//".fits" ) == 0 )
        {
          printf( "%s(%d)--(not exist. skip.)  ", fn, theta_n )
          printf( "%s(%d)--(not exist. skip.)  ", fn, theta_n, >> logfn )
          next
        }

        if( access( fnobe//".fits" ) == 1 || access( fnobo//".fits" ) == 1 )
        {
          if( flag_overwrite == 0 )
          {
            if( fnnexte != "none" && ( access( fnnexte//".fits" ) == 0 ||\
	        access( fnnexto//".fits" ) == 0 ) )
            {
	      printf( "\n%s(%d): Maybe insufficient proccess last time.\n",\
	              fn, theta_n )
	      printf( "\n%s(%d): Maybe insufficient proccess last time.\n",\
	              fn, theta_n, >> logfn )
              goto inquiry
            }

            if( flag_inquiry == 1 )
            {
              if( flag_ver == 1 )
                printf( "%s(%d)--(already exists. skip.)  ", fn, theta_n )
              printf( "%s(%d)--(already exists. skip.)  ", fn, theta_n,\
                      >> logfn )
              next
            }
            else
	    {
              printf( "\n%s(%d) already exist.\n", fn, theta_n )
              printf( "\n%s(%d) already exist.\n", fn, theta_n, >> logfn )
          inquiry:
              printf( "Overwrite? (apply-this-image-only:[y/n], all:[Y/N]) >> " )
              printf( "Overwrite? (apply-this-image-only:[y/n], all:[Y/N]) >> ", >> logfn )
              c = scan( buf )
              while( buf != "Y" && buf != "y" && buf != "n" && buf != "N" )
                c = scan( buf )
              if( buf == "Y" )
              {
                flag_inquiry = 1
                flag_overwrite = 1
              }
              if( buf == "N" )
              {
                flag_inquiry = 1
                flag_overwrite = 0
                if( flag_ver == 1 )
                  printf( "%s(%d)--(already exists. skip.)  ", fn, theta_n )
                printf( "%s(%d)--(already exists. skip.)  ",\
                        fn, theta_n, >> logfn )
                next
              }
              if( buf == "n" )
              {
                if( flag_ver == 1 )
                  printf( "%s(%d)--(already exists. skip.)  ", fn, theta_n )
                printf( "%s(%d)--(already exists. skip.)  ",\
                        fn, theta_n, >> logfn )
                next
              }
            }
          }
          if( flag_ver == 1 )
            printf( "%s(%d)(overwrite)  ", fn, theta_n )
          printf( "%s(%d)(overwrite)  ", fn, theta_n, >> logfn )
        }
        else
        {
          if( flag_ver == 1 )
            printf( "%s(%d)  ", fn, theta_n )
          printf( "%s(%d)  ", fn, theta_n, >> logfn )
        }

#----- flattening


  ## cosmic ray reduction 

        if( flag_cr == 1 )
        {
          if( access( tmp_fn5//".fits" ) == 1 )
            imdelete( tmp_fn5, ver- )

          lacos_spec( fnobe1, tmp_fn1, tmp_fn5, gain=10.0, readn=10.,\
                      xorder=0, yorder=2 )

          imdelete( tmp_fn5, ver- )

          lacos_spec( fnobo1, tmp_fn2, tmp_fn5, gain=10.0, readn=10.,\
                      xorder=0, yorder=2 )
          imdelete( tmp_fn5, ver- )
        }
        else
        {
          imcopy( fnobe1, tmp_fn1, ver- )
          imcopy( fnobo1, tmp_fn2, ver- )
        }
  
        imreplace( tmp_fn1, 0.0, lower=1.0e6, upper=INDEF )
        imreplace( tmp_fn2, 0.0, lower=1.0e6, upper=INDEF )


        imarith( tmp_fn1, "/", fnf1e1, tmp_fn1,\
                 pixtype="real", calctype="real", ver- )
        imarith( tmp_fn2, "/", fnf1o1, tmp_fn2,\
                 pixtype="real", calctype="real", ver- )
#        imarith( fnobe2, "/", fnf1e2, tmp_fn3,\
#                 pixtype="real", calctype="real", ver- )
#        imarith( fnobo2, "/", fnf1o2, tmp_fn4,\
#                 pixtype="real", calctype="real", ver- )
#
#        imarith( tmp_fn1, "-", tmp_fn3, tmp_fn1,\
#                 pixtype="real", calctype="real", ver- )
#        imarith( tmp_fn2, "-", tmp_fn4, tmp_fn2,\
#                 pixtype="real", calctype="real", ver- )

        if( access( fnobe//".fits" ) == 1 )
          imdelete( fnobe, ver- )
        if( access( fnobo//".fits" ) == 1 )
          imdelete( fnobo, ver- )


        background( tmp_fn1, fnobe, axis=2, interactive-, sample="*",\
                    naverage=1, function="legendre", order=1,\
                    low_rej=3.0, high_rej=1.0, niterate=3 )
        background( tmp_fn2, fnobo, axis=2, interactive-, sample="*",\
                    naverage=1, function="legendre", order=1,\
                    low_rej=3.0, high_rej=1.0, niterate=3 )

#        background( tmp_fn1, fnobe, axis=2, interactive-, sample="1:15,65:80",\
#                    naverage=1, function="legendre", order=1,\
#                    low_rej=1.5, high_rej=1.0, niterate=3 )
#        background( tmp_fn2, fnobo, axis=2, interactive-, sample="1:15,65:80",\
#                    naverage=1, function="legendre", order=1,\
#                    low_rej=1.5, high_rej=1.0, niterate=3 )

#imcopy( tmp_fn1, fnobe )
#imcopy( tmp_fn2, fnobo )


#        imarith( tmp_fn1, "*", fnf1e1, fnobe,\
#                 pixtype="real", calctype="real", ver- )
#        imarith( tmp_fn2, "*", fnf1o1, fnobo,\
#                 pixtype="real", calctype="real", ver- )

	if( access( fnobe//".fits" ) == 0 || access( fnobo//".fits" ) == 0 )
        {
	  printf( "Sky-subtraction failed. Abnormal end.\n" )
	  printf( "Sky-subtraction failed. Abnormal end.\n", >> logfn )
	  bye
	}

        hedit( fnobe, "HISTORY", "sky subtracted",\
               delete-, verify-, show-, update+ )
        hedit( fnobo, "HISTORY", "sky subtracted",\
               delete-, verify-, show-, update+ )

	if( flag_erase == 1 )
	{
	  imdelete( fnobe1, ver- )
	  imdelete( fnobo1, ver- )
	  imdelete( fnobe2, ver- )
	  imdelete( fnobo2, ver- )
	}

        imdelete( tmp_fn1, ver- )
        imdelete( tmp_fn2, ver- )
#        imdelete( tmp_fn3, ver- )
#        imdelete( tmp_fn4, ver- )
      }
      printf( "\n" )
      printf( "\n", >> logfn )
    }
  }

end
