#
#       TRI REDUCTION SUB ROUTINE
#
#       average UP data
#
#       1997/09/09      K.Kawabata ver.1.00
#       1997/05/31      K.Kawabata ver.2.10
#       1999/05/24      K.Kawabata ver.2.20  list diaph
#       2000/02/29      K.Kawabata ver.3.00  comment
#
#

procedure triupave

begin

  int fitorder = 7

#  string lupfileid = "u*l*0.tmp1"
#  string uupfileid = "u*u*0.tmp1"
  string lupfileid = "*0.ins"
  string uupfileid = "*0.ins"
#  string lupfileid = "U*0.ins"
#  string uupfileid = "U*0.ins"

  file avelist
  file fn_llog = "triupavel.dat"
  file fn_ulog = "triupaveu.dat"

  file lcortab, ucortab
  string fn[200], shdiaph[200]
  string cmnt[200]
  string buf = ""
  file tmp_fn1, tmp_fn2, tmp_fn3, tmp_fn4
  file tmp_list
  string uphead, diaph
  real lambda, q, qs, u, us
  real cq[10], cu[10]
  string buf1, buf2, buf3, buf4, buf5, buf6, buf7, buf8

  int c, i, j
  int n_list

  int flag_lsel, flag_usel

  buf1 = ""
  buf2 = ""
  tmp_list = mktemp( "tri.tmp.list." )
  tmp_fn1 = mktemp( "tri.tmp.fn." )
  tmp_fn2 = mktemp( "tri.tmp.fn." )
  tmp_fn3 = mktemp( "tri.tmp.fn." )
  tmp_fn4 = mktemp( "tri.tmp.fn." )

  print( "" )
  print( "-------------------" )
  print( " Averaging UP data"
  print( "-------------------" )
  print( "" )

  uphead = envget( "_uphead" )
  avelist = envget( "_avelog" )
  buf1 = ""

#
#----- check average log

  if( access( avelist ) == 0 )
  {
    printf( "'%s' not found.\n", avelist )
    bye
  }

#----- select diaphragm

  printf( "Select Diaphragm  [1]:2HL [2]:2S2  >> " )
  
  c = scan( buf )
  while( buf != "1" && buf != "2" )
    c = scan( buf )
  if( buf == "1" )
    diaph = "2HL"
  if( buf == "2" )
    diaph = "2S2"

  lcortab = uphead//diaph//"L"
  ucortab = uphead//diaph//"U"

#----- check old data file

  if( access( lcortab ) == 1 || access( ucortab ) == 1)
  {
    printf( "Detected old averaged table(s), '%s' or '%s'\n",\
            lcortab, ucortab )
    printf( "Delete? [y/n] >> ", fn_llog )
    c = scan( buf )
    while( buf != "n" && buf != "y" )
      c = scan( buf )
    if( buf == "n" )
    {
      printf( "Please rename '%s' and retry.\n", fn_llog )
      bye
    }
    if( access( lcortab ) )
      delete( lcortab, ver- )
    if( access( ucortab ) )
      delete( ucortab, ver- )
  }

  if( access( fn_llog ) == 1 )
  {
    printf( "Old '%s' exists. Delete? [y/n] >> ", fn_llog )
    c = scan( buf )
    while( buf != "n" && buf != "y" )
      c = scan( buf )
    if( buf == "n" )
    {
      printf( "Please rename '%s' and retry.\n", fn_llog )
      bye
    }
    delete( fn_llog, ver- )
    printf( "", >> fn_llog )
  }

  if( access( fn_ulog ) == 1 )
  {
    printf( "Old '%s' exists. Delete? [y/n] >> ", fn_ulog )
    c = scan( buf )
    while( buf != "n" && buf != "y" )
      c = scan( buf )
    if( buf == "n" )
    {
      printf( "Please rename '%s' and retry.\n", fn_ulog )
      bye
    }
    delete( fn_ulog, ver- )
    printf( "", >> fn_ulog )
  }

#----- make log file

lowerhole:

#----- lower hole

  flag_lsel = 0
  sections( lupfileid, option="fullname", >> tmp_list )
  n_list = sections.nimages
  if( n_list == 0 )
  {
    printf( "Cannot find any table. Skip lower hole.\n" )
    delete( tmp_list, ver- )
    goto upperhole
  }

  i = 0
  list = tmp_list
  while( fscan( list, buf ) != EOF )
  {
    i += 1
    fn[i] = buf
  }
  delete( tmp_list, ver- )

  for( i=1; i<=n_list; i+=1 )
  {
    shdiaph[i] = "UNDEF"
    buf7 = ""
    list = avelist
    while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7 ) != EOF )
    {
      if( buf == fn[i] )
      {
        shdiaph[i] = buf1
	cmnt[i] = buf7
	break
      }
      buf7 = ""
    }
  }

  printf( "Following tables are found\n" )
  for( i=1; i<=n_list; i+=1 )
    printf( "%2d :  %s %s %s\n", i, fn[i], shdiaph[i], cmnt[i] )

  printf( "Select for %s group\n", lcortab )

nextstep1:

  printf( "Input number to be averaged ([0]: end lower-hole) >> " )
  while( scan( buf ) != 1 ){}
  if( buf == "0" )
    goto upperhole
  c = int( buf )
  if( c < 0 || c > n_list )
    goto nextstep1

  printf( "%s\n", fn[c], >> fn_llog )
  flag_lsel += 1
  
  goto nextstep1

upperhole:

#----- upper hole

  flag_usel = 0
  sections( uupfileid, option="fullname", >> tmp_list )
  n_list = sections.nimages
  if( n_list == 0 )
  {
    printf( "Cannot find any table. Skip upper hole.\n" )
    delete( tmp_list, ver- )
    goto averaging
  }

  i = 0
  list = tmp_list
  while( fscan( list, buf ) != EOF )
  {
    i += 1
    fn[i] = buf
  }
  delete( tmp_list, ver- )

  for( i=1; i<=n_list; i+=1 )
  {
    shdiaph[i] = "UNDEF"
    buf7 = ""
    list = avelist
    while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7 ) != EOF )
    {
      if( buf == fn[i] )
      {
        shdiaph[i] = buf1
	cmnt[i] = buf7
	break
      }
      buf7 = ""
    }
  }

  printf( "Following tables are found\n" )
  for( i=1; i<=n_list; i+=1 )
    printf( "%2d :  %s %s %s\n", i, fn[i], shdiaph[i], cmnt[i] )

  printf( "Select for %s group\n", ucortab )

nextstep2:

  printf( "Input number to be averaged ([0]: end upper-hole) >> " )
  while( scan( buf ) != 1 ){}
  if( buf == "0" )
    goto averaging
  c = int( buf )
  if( c < 0 || c > n_list )
    goto nextstep2

  printf( "%s\n", fn[c], >> fn_ulog )
  flag_usel += 1
  
  goto nextstep2

averaging:
 
#---- average

  if( access( tmp_fn1 ) == 1 )
    delete( tmp_fn1, ver- )
  if( access( tmp_fn2 ) == 1 )
    delete( tmp_fn2, ver- )

  if( access( fn_llog ) == 0 )
  {
    printf( "Cannot find '%s'. Ignore lower hole.\n", fn_llog )
  }
  else
  {
    printf( "Averaging %s --> %s\n", fn_llog, tmp_fn1 )
    triupavesub( fn_llog, tmp_fn1 )
  }

  if( access( fn_ulog ) == 0 )
  {
    printf( "Cannot find '%s'. Ignore upper hole.\n", fn_ulog )
  }
  else
  {
    printf( "Averaging %s --> %s\n", fn_ulog, tmp_fn2 )
    triupavesub( fn_ulog, tmp_fn2 )
  }
#--- polynomial fitting

 #--- Lower

  if( access( tmp_fn3 ) == 1 )
    delete( tmp_fn3, ver- )
  if( access( tmp_fn4 ) == 1 )
    delete( tmp_fn4, ver- )
  if( access( tmp_list ) == 1 )
    delete( tmp_list, ver- )

printf( "ok1 %s\n", tmp_fn1 )
  list = tmp_fn1
  while( fscan( list, lambda, q, qs, u, us ) != EOF )
  {
    if( abs( q ) < 2.0 && abs( q ) > 1.0e-6 )
      printf( "%7.2f %8.4f\n", lambda, q, >> tmp_fn3 )
    if( abs( u ) < 2.0 && abs( u ) > 1.0e-6 )
      printf( "%7.2f %8.4f\n", lambda, u, >> tmp_fn4 )
  }

printf( "ok2\n" )
  curfit( tmp_fn3, function="legendre", weighting="uniform",\
          order=fitorder, interactive+, axis=1, listdata-, ver-,\
          calctype="double", power+, device="stdgraph", cursor="",\
          > tmp_list )
  delete( tmp_fn3, ver- )

printf( "ok3 %s\n", tmp_fn3 )
  list = tmp_list
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                buf6, buf7, buf8 ) != EOF )
  {
    if( buf == "#" && buf1 == "Power" && buf2 == "series" )
      break
    if( buf == "Power" && buf1 == "series" )
      break
  }
  if( buf != "Power" && buf1 != "Power" )
  {
    printf( "Format error in '%s'.\n", tmp_list )
  }
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                 buf6, buf7, buf8 ) != EOF )
  {
    if( strlen( buf ) != 1 )
      next
    if( buf == "#" && strlen( buf1 ) != 1 )
      next
    if( buf != "#" )
    {
      j = int( buf )
      if( j > 0 )
      {
        cq[j] = real( buf1 )
      }
    }
    else
    {
      j = int( buf1 )
      if( j > 0 )
      {
        cq[j] = real( buf2 )
      }
    }
  }
  delete( tmp_list, ver- )

  curfit( tmp_fn4, function="legendre", weighting="uniform",\
          order=fitorder, interactive+, axis=1, listdata-, ver-,\
          calctype="double", power+, device="stdgraph", cursor="",\
          > tmp_list )
  delete( tmp_fn4, ver- )
  list = tmp_list
  
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                buf6, buf7, buf8 ) != EOF )
  {
    if( buf == "#" && buf1 == "Power" && buf2 == "series" )
      break
    if( buf == "Power" && buf1 == "series" )
      break
  }
  if( buf != "Power" && buf1 != "Power" )
  {
    printf( "Format error in '%s'.\n", tmp_list )
  }
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                buf6, buf7, buf8 ) != EOF )
  {
    if( strlen( buf ) != 1 )
      next
    if( buf == "#" && strlen( buf1 ) != 1 )
      next
    if( buf != "#" )
    {
      j = int( buf )
      if( j > 0 )
      {
        cu[j] = real( buf1 )
      }
    }
    else
    {
      j = int( buf1 )
      if( j > 0 )
      {
        cu[j] = real( buf2 )
      }
    }
  }
  delete( tmp_list, ver- )

  list = tmp_fn1
  while( fscan( list, lambda, q, qs, u, us ) != EOF )
  {
    ## order == 3 ##
#    q = cq[1] + cq[2]*lambda + cq[3]*lambda*lambda
#    u = cu[1] + cu[2]*lambda + cu[3]*lambda*lambda
    ## order == 7 ##
    q = cq[1] + cq[2]*lambda + cq[3]*lambda*lambda + cq[4]*lambda**3\
        + cq[5]*lambda**4 + cq[6]*lambda**5 + cq[7]*lambda**6
    u = cu[1] + cu[2]*lambda + cu[3]*lambda*lambda + cu[4]*lambda**3\
        + cu[5]*lambda**4 + cu[6]*lambda**5 + cu[7]*lambda**6
    printf( "%7.2f %8.4f %7.4f %8.4f %7.4f\n", lambda,\
            q, qs, u, us, >> lcortab )
  }
  delete( tmp_fn1, ver- )

 #--- Upper

  if( access( tmp_fn3 ) == 1 )
    delete( tmp_fn3, ver- )
  if( access( tmp_fn4 ) == 1 )
    delete( tmp_fn4, ver- )
  if( access( tmp_list ) == 1 )
    delete( tmp_list, ver- )

  list = tmp_fn2
  while( fscan( list, lambda, q, qs, u, us ) != EOF )
  {
    if( abs( q ) < 2.0 && abs( q ) > 1.0e-6 )
      printf( "%7.2f %8.4f\n", lambda, q, >> tmp_fn3 )
    if( abs( u ) < 2.0 && abs( u ) > 1.0e-6 )
      printf( "%7.2f %8.4f\n", lambda, u, >> tmp_fn4 )
  }

  curfit( tmp_fn3, function="legendre", weighting="uniform",\
          order=fitorder, interactive+, axis=1, listdata-, ver-,\
          calctype="double", power+, device="stdgraph", cursor="",\
          > tmp_list )
  delete( tmp_fn3, ver- )
  list = tmp_list
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                 buf6, buf7, buf8 ) != EOF )
  {
    if( buf == "#" && buf1 == "Power" && buf2 == "series" )
      break
    if( buf == "Power" && buf1 == "series" )
      break
  }
  if( buf != "Power" && buf1 != "Power" )
  {
    printf( "Format error in '%s'.\n", tmp_list )
  }
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                 buf6, buf7, buf8 ) != EOF )
  {
    if( strlen( buf ) != 1 )
      next
    if( buf == "#" && strlen( buf1 ) != 1 )
      next
    if( buf != "#" )
    {
      j = int( buf )
      if( j > 0 )
      {
        cq[j] = real( buf1 )
      }
    }
    else
    {
      j = int( buf1 )
      if( j > 0 )
      {
        cq[j] = real( buf2 )
      }
    }
  }
  delete( tmp_list, ver- )

  curfit( tmp_fn4, function="legendre", weighting="uniform",\
          order=fitorder, interactive+, axis=1, listdata-, ver-,\
          calctype="double", power+, device="stdgraph", cursor="",\
          > tmp_list )
  delete( tmp_fn4, ver- )
  list = tmp_list
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                buf6, buf7, buf8 ) != EOF )
  {
    if( buf == "#" && buf1 == "Power" && buf2 == "series" )
      break
    if( buf == "Power" && buf1 == "series" )
      break
  }
  if( buf != "Power" && buf1 != "Power" )
  {
    printf( "Format error in '%s'.\n", tmp_list )
  }
  while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                 buf6, buf7, buf8 ) != EOF )
  {
    if( strlen( buf ) != 1 )
      next
    if( buf == "#" && strlen( buf1 ) != 1 )
      next
    if( buf != "#" )
    {
      j = int( buf )
      if( j > 0 )
      {
        cu[j] = real( buf1 )
      }
    }
    else
    {
      j = int( buf1 )
      if( j > 0 )
      {
        cu[j] = real( buf2 )
      }
    }
  }
  delete( tmp_list, ver- )

  list = tmp_fn2
  while( fscan( list, lambda, q, qs, u, us ) != EOF )
  {
    ## order == 3 ##
#    q = cq[1] + cq[2]*lambda + cq[3]*lambda*lambda
#    u = cu[1] + cu[2]*lambda + cu[3]*lambda*lambda
    ## order == 7 ##
    q = cq[1] + cq[2]*lambda + cq[3]*lambda*lambda + cq[4]*lambda**3\
        + cq[5]*lambda**4 + cq[6]*lambda**5 + cq[7]*lambda**6
    u = cu[1] + cu[2]*lambda + cu[3]*lambda*lambda + cu[4]*lambda**3\
        + cu[5]*lambda**4 + cu[6]*lambda**5 + cu[7]*lambda**6
    printf( "%7.2f %8.4f %7.4f %8.4f %7.4f\n", lambda,\
            q, qs, u, us, >> ucortab )
  }
  delete( tmp_fn2, ver- )

end




