#
#       TRISPEC REDUCTION SUB ROUTINE
#
#       initialization of global variables : triinit.cl
#
#       2006/11/15      K.Kawabata    Ver.0.50
#

#####################################
#                                   #
#         User Definitions          #
#                                   #
#####################################

### Channel [OPT/IR1/IR2]
  set _chan = "OPT"

#--- Directory Setting *** should be attatch '/' at the end ***

### Directory of  calib files
  set _caldir   = "/home/lecture/kawabata/trispec/cal/200610spol_OPT/"
### Directory of CL-scripts 
  set _clscript  = "/home/lecture/kawabata/trispec/clscript/"
### Directory of C-programs
  set _progdir   = "/home/lecture/kawabata/trispec/prog/"
### Directory of miscellaneous 
  set _etcdir    = "/home/lecture/kawabata/trispec/etc/"
### Directory of tables of spectrophotometric standards
  set _stddir    = "/home/lecture/kawabata/trispec/standard/"

#--- Run-time mode, Data Storage, etc.

### Display processing commands?
  set _fg_ver    = "1"  # 1:verbose, 2:little display
### If found old images which will be made next, Replace or Skip?
  set _fg_mode   = "1" # 1:replace, 2:skip, 3:query
### Delete the images of last process ? (Valid before 'hbsextract')
  set _fg_del1   = "2" # 1:erase old images, 2:keep
### Delete the images of last process ? (Valid at and after 'hbsextract')
  set _fg_del2   = "2" # 1:erase old images, 2:keep (hbsskysub-hbs1d)
#### Dark Averaging Mode
  set _fg_dark   = "1" # 1:group, 2:object, 3:exposure time
### Query at Bad pixel correction
  set _fg_badpix = "2" # 1:query, 2:no query
### q/u calculation mode for 2HOLE diaphragm
  set _iqucalc   = "1" # 1:variable sky, 2:clear and stable sky
### Error Estimation
  set _fg_err    = "1"  # 1:mean error (sigma/sqrt(n)), 2:standard deviation

### Reduction Mode
  set _objcal    = "1"  # 1: object obs. 2: UP,SP,GT obs.


#############################################
#                                           #
#      Don't Modify under this line !!      #
#                                           #
#############################################

set _logfile   = "TRI.log"               # log file
set _imagelist = "trilist.dat"           # Input image list
set _IR1ext    = "IR1"                  # IR1 detecter extention of filename
set _IR2ext    = "IR2"                  # IR2 detecter extention of filename
set _OPText    = "OPT"                  # OPT detecter extention of filename
set _rootlist  = "TRI.list"              # Prime list of HBSred
set _darklist  = "TRI.DARK.list"         # Dark group list
set _flatlist  = "TRI.FLAT.list"         # Flat group list

set _defhname  = "tridefine.h"           # C-program definition header
#set _badcol    = "_etcdir$badcol_1_opt.dat" # bad column table file
set _badpix    = "_caldir$badpix.fits"  # bad pixel table file
set _nullfile  = "_etcdir$null.dat"      # null file
set _features  = "TRI.feature.*"         # feature table (root file name) 
set _bintable  = "TRI.bintab.*"       # Binning factor table (root file name) 
set _featuren  = "_etcdir$TRI.feature.Aband"   # feature table (normal)
set _featuret  = "_etcdir$TRI.feature.TIOband" # feature table (TiO bands)
set _featureb  = "_etcdir$TRI.feature.E-Bal"   # feature table (Balmer em.)
set _photmet   = "triphot.par"           # photometric parameters

set _phlist    = "TRI.phot.list"         # Photmetric standard group list
set _iqulist   = "TRI.iqu.list"          # Iqu-group list
set _grouplist = "TRI.ave.list"          # Iqu-group average list
set _avelog    = "TRI.ave.log"           # Log of Iqu-average
set _phlog     = ".phot.log"          # log of hbsphcor
set _qlist     = ".q"                    # q-group list
set _ulist     = ".u"                    # u-group list
set _ilist     = ".i"                    # i-group list

set _fl2s21   = "FLAT.2S2.1t"   # 2SLIT02 first
set _fl2s22   = "FLAT.2S2.1t"   # 2SLIT02 second (modified first)
set _fl2s2p   = "FLAT.2S2.pxs"  # 2SLIT02 pixel sensitivity

set _up2hlu   = "KAP.2HL.Ut"     # 2HOLE kappa = k1 / k2
set _up2hll   = "KAP.2HL.Lt"     # 2HOLE kappa = k3 / k4
set _up2s2u   = "KAP.2S2.Ut"     # 2SLIT02 kappa = k1 / k2
set _up2s2l   = "KAP.2S2.Lt"     # 2SLIT02 kappa = k3 / k4
set _sensTI5  = "SENS.TI5"       # Spectral Sensitivity function image
set _sensSITe5 = "SENS.SITe5"    # Spectral Sensitivity function image
set _sensAndor = "SENS.Andor"    # Spectral Sensitivity function image

set _crostk   = "crostk"        # Cross-talk ratio spectra (.1, .2, .3)
set _2ndord   = "secord.dat"    # Pure 1st and 2nd order spectra

set _1to1we   = "f1to1we.tbl"   # 1-to-1-fit table (wavelength-dir, ext)
set _1to1wo   = "f1to1wo.tbl"   # 1-to-1-fit table (wavelength-dir, ord)
set _1to1se   = "f1to1se.tbl"   # 1-to-1-fit table (slit-length-dir, ext)
set _1to1so   = "f1to1so.tbl"   # 1-to-1-fit table (slit-length-dir, ord)
set _1to1sw   = "f1to1sw.tbl"   # 1-to-1-fit table (wavelength data of lines)

set _gthead   = "gtcor."        # root name of GT calibration file
set _uphead   = "upcor."        # root name of UP calibration file
set _sphead   = "spave."        # root name of SP calibration file

set _xsftlog   = "TRI.xsft.log"  # Output logfile of hbsarrange
set _ysftlog   = "TRI.ysft.log"  # Output logfile of hbs1d

set _hotpix    = 5000.0         # hot-pixel lower limit (ADU)
set _rej_x1    = 5000.0         # Starting wavelength for average in rejection
set _rej_x2    = 7000.0         # End wavelength for average in rejection

package hbs

#--- entry of C-programs

task    $trigcc = "$foreign"
task    $tri1dsub $trishiftsub $tricbin = "$foreign"
task    $tritfx $tritfy $trihotpxtab $tribvrilist $tricrescale = "$foreign"
task    $triiqupt $triipol $triconerrbin = "$foreign"
task    $tri2ossub $triscan2p $triscan2w = "$foreign"
task    $sed $triscan1p $trithorg $trigtavesub $triupavesub $triscan1 = "$foreign"

#--- entry of CL-script files

task $trired = _clscript$trired.cl
task $triccmpl = _clscript$triccmpl.cl
task $trifconv = _clscript$trifconv.cl
task $trigroup = _clscript$trigroup.cl
task $triparam = _clscript$triparam.cl
task $tridarkave = _clscript$tridarkave.cl
task $tridarksub = _clscript$tridarksub.cl
task $tritrim = _clscript$tritrim.cl
task tricoord = _clscript$tricoord.cl
task $tribadpix = _clscript$tribadpix.cl
task $tripixsens = _clscript$tripixsens.cl
task $triextract = _clscript$triextract.cl
task triapext = _clscript$triapext.cl
task $triskysub = _clscript$triskysub.cl
task trishift = _clscript$trishift.cl
task $triarrange = _clscript$triarrange.cl
task $tri1d = _clscript$tri1d.cl
task triap1d = _clscript$triap1d.cl
task $tribin = _clscript$tribin.cl
task $triiqugroup = _clscript$triiqugroup.cl
task $triiqumake = _clscript$triiqumake.cl
task $triiquave = _clscript$triiquave.cl
task triaverage = _clscript$triaverage.cl
task $trimktable = _clscript$trimktable.cl

task $hbscalrfits = _clscript$hbscalrfits.cl
task hbsdisplay = _clscript$hbsdisplay.cl
task $hbsreheader = _clscript$hbsreheader.cl
task $hbsdarkcor = _clscript$hbsdarkcor.cl
task hbscoordl = _clscript$hbscoordl.cl

task $triflat2 = _clscript$triflat2.cl
task $hbscntcor = _clscript$hbscntcor.cl

task triscy = _clscript$triscy.cl
task triscx = _clscript$triscx.cl
task $triclean = _clscript$triclean.cl
task $triflatcopy =_clscript$triflatcopy.cl

task $triphred = _clscript$triphred.cl
task $triphgroup = _clscript$triphgroup.cl
task $triphfit1 = _clscript$triphfit1.cl
task $triphfit2 = _clscript$triphfit2.cl
task $triphfit3 = _clscript$triphfit3.cl
task $triphfit4 = _clscript$triphfit4.cl
task $triphfit5 = _clscript$triphfit5.cl
task $triphcor = _clscript$triphcor.cl
task triphsig = _clscript$triphsig.cl
task triphbin = _clscript$triphbin.cl

task $triupsum1 = _clscript$triupsum1.cl
task $triupsum2 = _clscript$triupsum2.cl
task $triupsum3 = _clscript$triupsum3.cl
task $triupave = _clscript$triupave.cl
task trispave = _clscript$trispave.cl
task $trigtave = _clscript$trigtave.cl
task $tri1to1x = _clscript$tri1to1x.cl
task $triflatgroup =_clscript$triflatgroup.cl
task $trimakepix =_clscript$trimakepix.cl
task $triflatave =_clscript$triflatave.cl
task $triflatext =_clscript$triflatext.cl
task $triflatarr =_clscript$triflatarr.cl
task $triflatfit =_clscript$triflatfit.cl
task $tri1to1y = _clscript$tri1to1y.cl

task lacos_im = home$focas/clscript/lacos_im.cl
task lacos_spec = home$focas/clscript/lacos_spec.cl


#-- add for AndorCCD
task $andorconv = _clscript$andorconv.cl
task $andorhconv = _clscript$andorhconv.cl

keep

imred
onedspec
generic
obsolete
rv
#twodspec
#apextract
stsdas

keep

#--- Compile of C-programs & set PATH

triccmpl

#--- Rfits if *.imh not exist in the calibration directory

#hbscalrfits

printf( "'triinit' done. Calibration directry is set as\n" )
print( envget( "_caldir" ) )

set _initproc = "DONE"

keep
